
Redmine - Defect #13698

Wrong argument  error when sending email notifications after upgrading to 2.3.0

2013-04-05 19:34 - Mike Johnson

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Email notifications Estimated time: 0.00 hour

Target version:    

Resolution: Invalid Affected version: 2.3.0

Description

Email notifications were working yesterday. I upgraded to Redmine 2.3.0 last night, and today I noticed email notifications weren't

being sent out. I tried to send a test email and received the following error message:

An error occurred while sending mail (wrong argument (Fixnum)! (Expected kind of OpenSSL::SSL::SSLContext))

 I checked my configuration.yml to make sure it was copied over from the earlier version (2.1.2), and it was:

production:

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

      address: ourdomain.mail.eo.outlook.com

      port: 25

      domain: redmine.ourdomain.com

 I have tried changing the delivery method to async_smtp but received the same error message. As you can see from the

configuration, there is no SSL/TLS and no authentication. I also tried changing the domain name to a non-existant name, and

received the same error.

Here is my environment information:

Server OS: FreeBSD 9.

Redmine version: 2.3.0.stable

Ruby version: 1.8.7 (amd64-freebsd9)

Rails version: 3.2.13

Environment: production

Database adapter: MySQL

Related issues:

Related to Redmine - Defect #14174: email sendding problem when update 2.2.3 ... Closed

Related to Redmine - Defect #15775: Email delivery error: wrong argument (Fix... Closed

History

#1 - 2013-04-06 01:02 - Mike Johnson

- Status changed from New to Resolved

This just started working on it's own somehow. I have no idea what the problem was :(

#2 - 2013-04-06 06:25 - Toshi MARUYAMA

- Status changed from Resolved to Closed

Thank you for your feedback.

#3 - 2013-04-11 16:20 - Sebastián Moreno

- File Firefox.png added

Hey guys, I'm running on the exact same problem. I upgraded to 2.3.0 and mail just stopped working.
Email Configuration:

default:

email_delivery:

delivery_method: :smtp

smtp_settings:

address: mail.domain.com

port: 25

domain: "domain.com"

authentication: :login

user_name: "no-reply@domain"

openssl_verify_mode: "none"

I don't even know were to look. :(

Server OS: Debian Squeeze 6.0.6.

Redmine version: 2.3.0.stable

Ruby version: ruby 1.8.7 (2010-08-16 patchlevel 302) [x86_64-linux]

Rails version: 3.2.13

Environment: production

Database adapter: MySQL

Thanks!

#4 - 2013-04-11 17:00 - Toshi MARUYAMA

- Status changed from Closed to Reopened

#5 - 2013-04-12 17:35 - Sebastián Moreno

There is anything I can do to give you more information? Some kind of log or something?

#6 - 2013-04-12 17:39 - Etienne Massip

Try sending a test email from Administration/Settings tab and have a lokk to your production.log contents.

#7 - 2013-04-12 18:51 - Sebastián Moreno

Ok, I did it, but there is nothing related to the send mail error, just the rendering of the page and sql queries.

#8 - 2013-04-12 20:00 - Etienne Massip

- Status changed from Reopened to Closed

- Resolution set to Invalid

Move your settings from the default entry to the production one (at the end of the file).

#9 - 2013-04-12 20:16 - Sebastián Moreno

Changed to this:

production:

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

      address: mail.********..com

      port: 25

      domain: "********..com" 

      authentication: :login

      user_name: "no-reply@********.com" 

      password: "******" 

      openssl_verify_mode: "none" 

 Nothing happened, same error.

I don't have any other configuration on the file. If I change (for example the last line: openssl_verify_mode) the error is different (a previous mailer

error) so I think it's using correctly the config.

#10 - 2013-04-13 10:17 - Toshi MARUYAMA

- Status changed from Closed to Reopened

#11 - 2013-04-13 10:18 - Toshi MARUYAMA
- Resolution deleted (Invalid)

#12 - 2013-04-13 12:51 - Toshi MARUYAMA

Could you try this?

http://www.redmine.org/boards/2/topics/37008

#13 - 2013-04-15 09:12 - Etienne Massip

I think Toshi is right, I didn't see your screenshot in the first place.

#14 - 2013-04-15 17:03 - Sebastián Moreno

Perfect! It works! Thanks a lot guys :)

#15 - 2013-04-15 18:21 - Etienne Massip

- Status changed from Reopened to Closed

- Resolution set to Invalid

#16 - 2013-05-17 12:26 - Jorge Cabrera

Hi, I'm having the same problem after upgrading to 2.3.1. Toshi's solution didn't work on my case because Exchange Online requires TLS. I opened

an issue with this (#37885). Can someone please guide me on how to solve this problem? My configuration is this:

production:

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

      enable_starttls_auto: true

      address: "pod51016.outlook.com" 

      port: '587'

      authentication: :login

      user_name: "theuser@thedomain" 

      password: "thepassword" 

#17 - 2013-05-17 15:05 - Jean-Philippe Lang

First, try to remove the quotes around the port then restart Redmine.

#18 - 2013-05-17 17:34 - Artur Smolarek

I can confirm Jorge's problem. I have already updated Redmine to 2.3.1.

My e-mail configuration looks like:

default:

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

      address: "xyz.com" 

      port: 587

      authentication: :login

      user_name: "user@xyz.com" 

      password: "mypasswd" 

      enable_starttls_auto: true

 Output of the mail test:

An error occurred while sending mail (wrong argument (NilClass)! (Expected kind of OpenSSL::SSL::SSLContext))

 I tried also to install "always_verify_ssl_certificates" gem but without any positive results.

Any idea?

#19 - 2013-05-24 13:26 - Rodrigo Braz

I still have the same problem as above, no recommended fix worked.

Stopped working after the update to 2.3, and I'm using settings for a google apps email.

I think it has something to do with the openssl_verify_mode property. I have it set to

openssl_verify_mode: 'none'
 but if I remove the line the error changes to wrong argument (NilClass) instead of (FixNum).

#20 - 2013-05-24 17:57 - BTR Naidu

Same error here.  Any more ideas guys?

#21 - 2013-05-24 23:41 - Oscar Moncada

I'm having a similar issue, just updated to version 2.3.1 and I can't get the notification emails to work.

I get the following error:

An error occurred while sending mail (wrong argument (NilClass)! (Expected kind of OpenSSL::SSL::SSLContext))

 This is my configuration:

production:

   email_delivery:

     delivery_method: :smtp

     smtp_settings:

       address: smtp.gmail.com

       port: 587

       domain: smtp.gmail.com

       authentication: :plain

       user_name: my.address@my-domain.com

       password: mypassword

 This is my redmine environment:

Environment:

  Redmine version                          2.3.1.stable

  Ruby version                             1.8.7 (x86_64-linux)

  Rails version                            3.2.13

  Environment                              production

  Database adapter                         Mysql2

Redmine plugins:

  no plugin installed

 I've tried everything from switching to async_smtp (which generates a success message but does not send out the email) to setting 

enable_starttls_auto to false (which generates a different error message that says I must set the starttls first) to using/not using quotes on the

username and password parameters, etc. Nothing seems to work :-(

Any help would be greatly appreciated!

#22 - 2013-05-25 19:16 - Dmitry Glavchev

I managed somehow to resolve this for non-SSL/TLS case. Not sure how exactly, I was just playing with config and was going to debug ruby gems

responsible for mail delivery but suddenly it just started sending emails. My Redmine is 2.3.1-devel and here is my email config:

default:

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

      enable_starttls_auto: false

      address: smtp.someserver.com

      port: 25

      authentication: :login

      user_name: usernameWithoutQuotes

      password: passwordWithoutQuotes

      openssl_verify_mode: 'none'

 Please also note that I've added same email_delivery stuff in production: section in the end of the file configuration.yml.

Certainly some of those configuration settings helped but now I don't want to touch anything :) let it just work.

After changing config restart your Redmine webserver, it looks like ruby scripts can be heavily cached.

#23 - 2013-05-25 23:48 - BTR Naidu

Did you use gmail smtp server?  I see you are using port 25.  Guess gmail does not use port 25?

#24 - 2013-05-27 06:13 - Anonymous

I use sendmail function on CentOS 5.8 final, but I also have the same problem. On setting in Administrator, I used "send test email" And redmine said
"sent sucessfull" but I did not receive any email

#25 - 2013-05-28 09:51 - BTR Naidu

Any update guys?  Anybody had similar issue before and were able to resolve?

#26 - 2013-05-28 11:10 - XDjuj Apsulis

Like answered before, the fix is here :

- http://www.redmine.org/boards/2/topics/37008

Juste change "openssl_verify_mode 'none'" with "enable_starttls_auto: false" in your config/configuration.xml file.

In my simple case, it now works with :

# default configuration options for all environments

default:

  # Outgoing emails configuration (see examples above)

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

      address: localhost

      port: 25

      domain: mydomain.com           

      enable_starttls_auto: false

     # openssl_verify_mode: 'none' ==> this line is not working anymore on redmine 2.3.x

     # authentication: :login

     # user_name: "redmine@example.net" 

     # password: "redmine" 

  # Absolute path to the directory where attachments are stored.

#27 - 2013-05-28 21:06 - Rodrigo Braz

XDjuj Apsulis wrote:

Like answered before, the fix is here :

- http://www.redmine.org/boards/2/topics/37008

Juste change "openssl_verify_mode 'none'" with "enable_starttls_auto: false" in your config/configuration.xml file.

In my simple case, it now works with :

[...]

 This is not a solution. Some email config require tls, which is the case of gmail, so setting it to false won't work anyway.

Removing "openssl_verify_mode" and setting "enable_starttls_auto: true" will give the following error

An error occurred while sending mail (wrong argument (NilClass)! (Expected kind of OpenSSL::SSL::SSLContext))

#28 - 2013-05-28 23:27 - Oscar Moncada

I tried making those changes and still get the same error as before. Has anyone gotten this to work with gmail?

#29 - 2013-05-29 12:25 - Peter Panther

The problem

An error occurred while sending mail (wrong argument (NilClass)! (Expected kind of OpenSSL::SSL::SSLContext))

ist caused by the gem package 'mail' in version 2.5.4 (released on the 14th of may 2013)

(for further details have a look at https://github.com/mikel/mail/issues/548)

All Redmine installations/updates after this date will have the TLS-negotiation problem if ruby 1.8.7 is still used.

Downgrade to version 2.5.3 and TLS-encryption works as before......

#30 - 2013-05-29 16:55 - Mikael Nehlsen

I also have this problem, A small question for a non fluent ruby speaker. how do you downgrade mail I did

gem install mail -v 2.5.3

gem uninstall mail -v 2.5.4
but then I got a nice big error in my redmine installation saying something like this:

Could not find mail-2.5.4 in any of the sources (Bundler::GemNotFound)

#31 - 2013-05-29 18:04 - Mikael Nehlsen

Being impatient I tried some things and found out that what did work was

gem install mail -v 2.5.3

edit the file Gemfile.lock in the redmine root dir update from mail (2.5.4) to mail (2.5.3) and restart in my case apache.

#32 - 2013-05-30 00:56 - Oscar Moncada

Downgrading to mail -v 2.5.3 fixed the issue for me. THANK YOU!!!!

#33 - 2013-05-30 12:02 - Anonymous

This solution is not work for me. Downgrading to 2.5.3 the problem is not change. Please view my issue at: 

http://www.redmine.org/boards/2/topics/37850

#34 - 2013-07-16 10:15 - Kuba Zwolinski

Downgrading mail worked for me, thanks.

#35 - 2013-07-19 09:52 - Tomas Latal

Downgrading to mail 2.5.3 and changing dependency in Gemfile.lock from mail 2.5.4 to 2.5.3 worked for me too. Thank you.

#36 - 2013-08-15 15:53 - Christian Rost

Mikael Nehlsen wrote:

Being impatient I tried some things and found out that what did work was

gem install mail -v 2.5.3

edit the file Gemfile.lock in the redmine root dir update from mail (2.5.4) to mail (2.5.3) and restart in my case apache.

 That did it - downgraded mail to 2.5.3; changed mail dependency in Gemfile.lock to 2.5.3; restarted apache; notification mails are sent again. ;-)

#37 - 2013-09-12 15:56 - Raphael PRIVAT

Hello,

I had the same problem with my gmail account and downgrading to 2.5.3 worked.

BUT ... It only works with gmail !

I have a mail server with TLS that I used to access from an older Redmine version (2.1.2 , mail 2.4.4) and everything worked.

Now, with the same configuration.yml (2.3.2, mail 2.5.3 or 2.5.4) it doesn't work.

smtp_settings:

enable_starttls_auto: true

openssl_verify_mode : 'none'

address: "mail.mydomain.com"

port: 587

domain: "mydomain.com"

authentication: :plain

user_name: user@mydomain.com

password: userpass

My certificate is auto signed so I have to set openssl_verify_mode : 'none' and TLS is mandatory.

user and password quoted or unquoted, nothing will do the trick.

Did someone manage to use a TLS account other than GMail ?

#38 - 2013-09-16 14:59 - Vladimir Skubriev

My certificate is auto signed so I have to set openssl_verify_mode : 'none' >and TLS is mandatory.

user and password quoted or unquoted, nothing will do the trick.

 I think that it is not ruby mail 2.5.4 problem.
I think that problem is you own Certificate Authority is not trusted by a redmine server system running.

google: update-ca-certificates and other methods to add ca to system store /etc/ssl

#39 - 2013-09-24 12:40 - Vladimir Skubriev

I changed the setting "tls" to false and it worked.

See part of my configuration.yml

# default configuration options for all environments

default:

  # Outgoing emails configuration (see examples above)

  email_delivery:

    delivery_method: :smtp

    smtp_settings:

     tls: false

      enable_starttls_auto: true

      address: "smtp.yandex.ru" 

      port: '587'

      domain: mydomainatyandex.com

      authentication: :plain

      user_name: "user@mydomainatyandex.com" 

      password: "pass" 

Also this work with 2.5.3 and 2.5.4 mail gem version.

I suspect that the port is not significant. You can use 25 or 587 with yandex. With google best way to use 587 port.

#40 - 2013-10-17 16:06 - Adrien Crivelli

Same here, ran sudo gem install mail -v 2.5.3 and edited Gemfile.lock manually to re-enable email notifications.

In my opinion this issue should not be closed until a new mail version is released, which would actually fix the bug.

#41 - 2013-10-24 17:30 - Yuri Yurip

Hello people,

I will to become crazy with this mail notification !

I always get this error message:

Erreur lors de l'envoi de l'email (wrong argument (NilClass)! (Expected kind of OpenSSL::SSL::SSLContext))

Already try to:

-Downgrade mail version to 2.5.3.

-Change configuration file with different parameters

My config:

Ubuntu 12.x LTS 64 bit under VM

Environment:

Redmine version                2.3.3.stable

Ruby version                   1.8.7-p352 (2011-06-30) [x86_64-linux]

Rails version                  3.2.13

Environment                    production

Database adapter               MySQL

Redmine plugins:

no plugin installed

My configuration.yml file:

production:

   email_delivery:

     delivery_method: :smtp

     smtp_settings:

       enable_starttls_auto:false

       openssl_verify_mode: 'none'

       address: "smtp.gmail.com" 

       port: '587'

       domain: "smtp.gmail.com" 

       authentication: :plain

       user_name: email_name

       password: my_password
 Any help will be apreciated thank !

#42 - 2013-11-13 13:58 - Сергей Нерволь

All work fine.

apt-cache policy ruby1.9.3

ruby1.9.3:

Установлен: 1.9.3.0-1ubuntu2.7

Кандидат:   1.9.3.0-1ubuntu2.7

Environment:

Redmine version                2.3.3.stable

Ruby version                   1.8.7-p352 (2011-06-30) [x86_64-linux]

Rails version                  3.2.13

Environment                    production

Database adapter               PostgreSQL

Redmine plugins:

no plugin installed

My actions to make it works:

1. Changed Gemfile.lock: changed line mail (2.5.4)  -->  mail (2.5.3)

2. gem install mail -v 2.5.3

3. gem uninstall mail -v 2.5.4

4. service apache2 restart

cat ./configuration.yml

production:

  delivery_method: :smtp

  smtp_settings:

    enable_starttls_auto: true

    address: smtp.gmail.com

    port: 587

    domain: "my.domain" 

    authentication: :login

    user_name: "robot@my.domain" 

    password: "password" 

#43 - 2013-11-25 12:50 - Erlend ter Maat

When I downgrade mail to 2.5.3 a dependency for actionmailer breaks.

How can I downgrade "mail" without breaking the dependency?

#44 - 2013-12-21 10:17 - Plam Sim

Downgrade to 2.5.3 and changing dependencies in "Gemfile.lock" - 2 rows for mail.

However only after implementing the right syntax described in http://www.redmine.org/boards/2/topics/30670 worked for me.

Redmine 2.4.1 with Gmail SMTP method.

#45 - 2013-12-30 11:46 - Jan from Planio www.plan.io

- Related to Defect #15775: Email delivery error: wrong argument (Fixnum)! (Expected kind of OpenSSL::SSL::SSLContext) added

#46 - 2014-06-29 18:58 - Miquel Coll

Mikael Nehlsen wrote:

Being impatient I tried some things and found out that what did work was

gem install mail -v 2.5.3

edit the file Gemfile.lock in the redmine root dir update from mail (2.5.4) to mail (2.5.3) and restart in my case apache.

 Thanks! This also worked for me. I'm using redmine 2.4.5 and a Gmail account in configuration.yml.

#47 - 2014-10-06 17:52 - Alexander Dunin

My settings for mandrill

email_delivery:
  delivery_method: :smtp

  smtp_settings:

    address: "smtp.mandrillapp.com" 

    port: 587

    domain: "smtp.mandrillapp.com" 

    authentication: :plain

    user_name: "username@example.com" 

    password: "password" 

    openssl_verify_mode: OpenSSL::SSL::VERIFY_NONE

    enable_starttls_auto: false

#48 - 2014-11-24 06:47 - Jin Ma

My Redmine version is 2.6.0

When I configure my email, I got an error:

Email delivery error: wrong argument (Fixnum)! (Expected kind of OpenSSL::SSL::SSLContext)

here is my configs

production:

  delivery_method: :smtp

  smtp_settings:

    ssl: true

    enable_starttls_auto: true

    openssl_verify_mode: 'none'

    address: "smtp.exmail.qq.com" 

    port: 465 

    domain: "zuinianqing.com" 

    authentication: :login

    user_name: "redmine@zuinianqing.com" 

    password: "XXXXXXX" 

 Could you help me?

#49 - 2015-02-14 11:55 - Allen Huang

I found the solution from http://www.parorrey.com/blog/project-management/redmine-email-configuration-resolve-sending-email-notifications/ works

for me.

The key is adding followings  to configuration.yml file

      enable_starttls_auto: false

      openssl_verify_mode: none
